%Main function for the algorithm total bounded variation

%close all
%% Parameters
gamma=0.01;
lambda=0.0005;

kmax=50;
fignum=1;

%% Noisy image and original image
disp('------------------------');
orgI=double(imread('lena256.gif'))/255;
[m1,m2]=size(orgI);
figure(1),imshow(noiI);


%% TBV algorithm with matrix format for SP
ii=3;
switch ii
    case 1
        pm=3;
        pn=3;
        PSF=fspecial('gaussian',[pm*2+1 pn*2+1],5)
        blur='gauss';
    case 2
        pm=3;
        pn=3;
        PSF=out_of_focus(3)
        blur='out';
    case 3
        pm=1;
        pn=4;
        PSF=fspecial('motion',9,1)        
        blur='motion';
end
for noise=0.5:0.2:0.5
    noise
    fname=strcat('lena_',blur,'_sp_',num2str(round(noise*100)));
    noiI=imnoise(convb(orgI,PSF,pm,pn),'salt & pepper', noise);
    %load(fname,'noiI');
    imwrite(noiI,strcat('lena_gauss_spnoiI(noise=',num2str(noise),').tif'));
    save(fname,'noiI');
    for alpha=0.01:0.001:0.025
        alpha
        u=ITBV_restoration_sp2(noiI,gamma,lambda,alpha,kmax,PSF,m1,m2,pm,pn);
        figure,imshow(u)
        imwrite(u,strcat('reslenaI_',blur,'_spITV(noise=',num2str(noise),',alpha=',num2str(alpha),',psnr=',num2str(psnr),').tif'));
    end
end



%% TBV algorithm with matrix format for RD
% ii=3;
% switch ii
%     case 1
%         pm=3;
%         pn=3;
%         PSF=fspecial('gaussian',[pm*2+1 pn*2+1],5)
%         blur='gauss';
%     case 2
%         pm=3;
%         pn=3;
%         PSF=out_of_focus(3)
%         blur='out';
%     case 3
%         pm=1;
%         pn=4;
%         PSF=fspecial('motion',9,1)        
%         blur='motion';
% end
% for noise=0.2:0.2:0.2
%     noise
%     fname=strcat('lena_',blur,'_rd_',num2str(round(noise*100)));
%     noiI=impnoise(convb(orgI,PSF,pm,pn),noise);
%     imwrite(noiI,strcat('lena_gauss_spnoiI(noise=',num2str(noise),').tif'));
%     
%     u=noiI*255;
%     F=ones(m1,m2);
%     for ii=1:4
%         switch ii
%         case 4
%             delta = [40, 25, 10, 5];
%         case 3
%             delta = [60, 45, 30, 25];
%         case 2
%             delta = [80, 65, 50, 45];
%         case 1
%             delta = [100, 85, 70, 65];
%         end
%         [u,F]=ACWMfilter(u,F,delta);
%     end
%     u0=u./255;
%     
%     for alpha=0.025:0.001:0.04
%         alpha
%         u=ITBV_restoration_rd2(noiI,u0,F,gamma,lambda,alpha,kmax,PSF,m1,m2,pm,pn);
%         
%         figure,imshow(u)
%         imwrite(u,strcat('reslenaI_',blur,'_rdITV(noise=',num2str(noise),',alpha=',num2str(alpha),',psnr=',num2str(psnr),').tif'));
%     end
% end


%% The End
